﻿using System;
using System.Linq;

using DomainModel;
using IdeaBlade.EntityModel;

namespace Console01 {
  class Program {
    static void Main(string[] args) {
      new Program().DoIt();
    }

    private void DoIt() {
      _context = new DomainModelEntityManager();
      Customer aCustomer = _context.Customers.Where(c=> c.Orders.Any()).FirstOrNullEntity();

      int numberOfEntitiesDeleted = aCustomer.DeleteObjectGraph();

      Console.WriteLine("Entities marked for deletion: " + numberOfEntitiesDeleted);

      // We don't actually delete these entities from the database here. If you want to do so, uncomment the following
      //SaveResult sr = _context.SaveChanges();

      PromptToContinue();
    }

    private void PromptToContinue() {
      Console.WriteLine();
      Console.WriteLine("Press ENTER to continue...");
      Console.ReadLine();
    }

    #region Private Fields
    DomainModelEntityManager _context;
    #endregion Private Fields
  }
}
