﻿using System;
using System.Linq;

using IdeaBlade.EntityModel;
using IdeaBlade.Core;

namespace DomainModel {

  public partial class Customer {

    /// <summary>
    /// Deletes the Customer, its related orders and international orders, and their related OrderDetails
    /// </summary>
    public int DeleteObjectGraph() {

      int counter = 0;

      foreach (var order in this.Orders.ToList()) {
        foreach (var dtl in order.OrderDetails.ToList()) {
          dtl.EntityAspect.Delete();
          counter++;
        }
        if (!order.InternationalOrder.EntityAspect.IsNullEntity) {
          order.InternationalOrder.EntityAspect.Delete();
          counter++;
        }
        order.EntityAspect.Delete();
        counter++;
      }

      this.EntityAspect.Delete();
      counter++;

      return counter;
    }

  }

}
