﻿Imports DomainModel
Imports IdeaBlade.EntityModel

Namespace Console01
  Friend Class Program
	Shared Sub Main(ByVal args() As String)
	  CType(New Program(), Program).DoIt()
	End Sub

	Private Sub DoIt()
	  _context = New DomainModelEntityManager()
	  Dim aCustomer As Customer = _context.Customers.Where(Function(c) c.Orders.Any()).FirstOrNullEntity()

	  Dim numberOfEntitiesDeleted As Integer = aCustomer.DeleteObjectGraph()

	  Console.WriteLine("Entities marked for deletion: " & numberOfEntitiesDeleted)

	  ' We don't actually delete these entities from the database here. If you want to do so, uncomment the following
	  'SaveResult sr = _context.SaveChanges();

	  PromptToContinue()
	End Sub

	Private Sub PromptToContinue()
	  Console.WriteLine()
	  Console.WriteLine("Press ENTER to continue...")
	  Console.ReadLine()
	End Sub

	#Region "Private Fields"
	Private _context As DomainModelEntityManager
	#End Region ' Private Fields
  End Class
End Namespace
